class User < ActiveRecord::Base
  belongs_to :role
  has_many :certs

  def self.create_with_omniauth(auth)
    create! do |user|
      user.provider = auth['provider']
      user.uid = auth['uid']
      info = auth['info']
      user.name = info['name'] || user.uid
      user.email = info['email']
      user.number = info['number']
    end
  end

  def self.create_from_tsv(email, name)
    create! do |user|
#      user.provider = 'SYNC'
      user.name = name
      user.email = email
    end
  end

  def self.update_with_omniauth(user, auth)
    user.provider = auth['provider']
    user.uid = auth['uid']
    info = auth['info']
    user.name = info['name'] || user.uid
    user.email = info['email']
    user.number = info['number']
    user.save!
  end

end
