Shibcert::Application.routes.draw do

  root to: redirect("/#{I18n.default_locale}")

  scope '(:locale)', locale: /ja|en/ do  
    root "certs#index", as: "locale_root"
    
    post "certs/request_post"
    get "certs/request_result/:id", to: 'certs#request_result', \
        as: 'request_result'

    post "certs/disable_post/:id",  to: 'certs#disable_post', \
        as: 'disable_post'         
    get "certs/disable_result/:id", to: 'certs#disable_result', \
        as: 'disable_result'

    get "certs/admin"
    
    resources :certs do
      member do
        post "edit_memo_remote"
      end
    end

#    resources :cert_states
    
#    resources :cert_types
    
#    resources :users
    
#    resources :roles
    
#    resources :requests
    
    get '/auth/:provider/callback' => 'sessions#create'
    get '/auth/:failure' => 'sessions#failure'
    get '/signout' => 'sessions#destroy', :as => :signout
    
    # The priority is based upon order of creation: first created -> highest priority.
    # See how all your routes lay out with "rake routes".
    
    # You can have the root of your site routed with "root"
    # root 'welcome#index'
    
    # Example of regular route:
    #   get 'products/:id' => 'catalog#view'
    
    # Example of named route that can be invoked with purchase_url(id: product.id)
    #   get 'products/:id/purchase' => 'catalog#purchase', as: :purchase
    
    # Example resource route (maps HTTP verbs to controller actions automatically):
    #   resources :products
    
    # Example resource route with options:
    #   resources :products do
    #     member do
    #       get 'short'
    #       post 'toggle'
    #     end
    #
    #     collection do
    #       get 'sold'
    #     end
    #   end
    
    # Example resource route with sub-resources:
    #   resources :products do
    #     resources :comments, :sales
    #     resource :seller
    #   end
    
    # Example resource route with more complex sub-resources:
    #   resources :products do
    #     resources :comments
    #     resources :sales do
    #       get 'recent', on: :collection
    #     end
    #   end
    
    # Example resource route with concerns:
    #   concern :toggleable do
    #     post 'toggle'
    #   end
    #   resources :posts, concerns: :toggleable
    #   resources :photos, concerns: :toggleable
    
    # Example resource route within a namespace:
    #   namespace :admin do
    #     # Directs /admin/products/* to Admin::ProductsController
    #     # (app/controllers/admin/products_controller.rb)
    #     resources :products
    #   end
  end

  get  'mail',           to: 'mail#index'
  get  'mail/processor', to: 'mail#processor'
  post 'mail/processor', to: 'mail#processor'

end
